#include <stdio.h>
#include "mcu_init.h"
#include "config.h"
#include "device.h"
#include "spi2.h"
#include "socket.h"
#include "w5500.h"
#include "at24c16.h"
#include "util.h"
#include "dhcp.h"
#include "UPnP.h"
#include "hyperterminal.h"

extern uint8 txsize[];
extern uint8 rxsize[];

uint8 Enable_DHCP = ON;
uint8 IP[4] = {192, 168, 1, 115};
uint8 FTP_SERVER_IP[4] = {192, 168, 1, 106};			//FTP Server IP Address

uint8 TX_BUF[TX_RX_MAX_BUF_SIZE];
uint8 RX_BUF[TX_RX_MAX_BUF_SIZE];

uint8 buffer[2048];/*һ2KBĻ*/
  
void main()
{ 
  uint8 dhcpret=0;
  RCC_Configuration(); /* õƬϵͳʱ*/
  GPIO_Configuration();/* GPIO*/
  NVIC_Configuration();/* Ƕж*/
  
  Systick_Init(72);/* ʼSystickʱ*/
  USART1_Init(); /*ʼͨ:115200@8-n-1*/
  at24c16_init();/*ʼeeprom*/
  get_config();
  printf("W5500 EVB initialization over.\r\n");
  
  Reset_W5500();/*ӲW5500*/
  WIZ_SPI_Init();/*ʼSPIӿ*/
  printf("W5500 initialized!\r\n");  
  
  if(Enable_DHCP == ON){
      init_dhcp_client();
      Delay_ms(1000);
      while(dhcpret!=DHCP_RET_UPDATE)
      {
        dhcpret = check_DHCP_state(SOCK_DHCP);
        
        switch(dhcpret)
        {
          case DHCP_RET_NONE:
            break;
          case DHCP_RET_TIMEOUT:
            break;
          case DHCP_RET_UPDATE:
            break;
          case DHCP_RET_CONFLICT:
            while(1);
          default:
            break;
        }
      }
  }
  else
  {
     set_default();
  }
  
  set_network();
      
  Timer_Configuration();
  
  // Start Application
  printf("\r\n\r\n-----------------------------------\r\n");
  printf("UPnP Portforward using W5500\r\n");  
  printf("-----------------------------------\r\n");
  
  // Try to SSDP Process
  do{
          printf("Send SSDP..\r\n");
  }while(SSDPProcess(SOCK_SSDP)!=0);
  
  // Try to Get Description of IGD
  if(GetDescriptionProcess(SOCK_UPNP)==0) printf("GetDescription Success!!\r\n");
  else printf("GetDescription Fail!!\r\n");
  
  // Try to Subscribe Eventing
  if(SetEventing(SOCK_UPNP)==0) printf("SetEventing Success!!\r\n");
  else printf("SetEventing Fail!!\r\n");
  
  Main_Menu();
  
  while(1) {
  }
}