#ifndef __CONFIG_H__
#define __CONFIG_H__

#include "stm32f10x.h"
#include "Types.h"
#include "device.h"

//=================================================
// Port define 

// Port A
#define PA0				GPIO_Pin_0	// out
#define PA1				GPIO_Pin_1	// out
#define PA2				GPIO_Pin_2	// 
#define PA3				GPIO_Pin_3	// 
#define PA4				GPIO_Pin_4	// 
#define PA5				GPIO_Pin_5	// 
#define PA6				GPIO_Pin_6	// 
#define PA7				GPIO_Pin_7	// 
#define PA8				GPIO_Pin_8	// 
#define PA9				GPIO_Pin_9	// 
#define PA10				GPIO_Pin_10	// 
#define PA11				GPIO_Pin_11	// 
#define PA12				GPIO_Pin_12	// 
#define PA13				GPIO_Pin_13	// 
#define PA14				GPIO_Pin_14	// 
#define PA15				GPIO_Pin_15	// 



//Port B

#define PB0                             GPIO_Pin_0
#define PB1				GPIO_Pin_1	// 
#define PB2				GPIO_Pin_2	// 
#define PB3				GPIO_Pin_3	// 
#define PB4				GPIO_Pin_4	// 
#define PB5				GPIO_Pin_5	// 
#define PB6				GPIO_Pin_6	// 
#define PB7                             GPIO_Pin_7
#define PB8                             GPIO_Pin_8
#define PB9                             GPIO_Pin_9
#define PB10                            GPIO_Pin_10
#define PB11                            GPIO_Pin_11
#define PB12                            GPIO_Pin_12
#define PB13                            GPIO_Pin_13
#define PB14                            GPIO_Pin_14
#define PB15                            GPIO_Pin_15

//Port C

#define PC0                             GPIO_Pin_0
#define PC1				GPIO_Pin_1	// 
#define PC2				GPIO_Pin_2	// 
#define PC3				GPIO_Pin_3	// 
#define PC4				GPIO_Pin_4	// 
#define PC5				GPIO_Pin_5	// 
#define PC6				GPIO_Pin_6	// 
#define PC7                             GPIO_Pin_7
#define PC8                             GPIO_Pin_8
#define PC9                             GPIO_Pin_9
#define PC10                            GPIO_Pin_10
#define PC11                            GPIO_Pin_11
#define PC12                            GPIO_Pin_12
#define PC13                            GPIO_Pin_13
#define PC14                            GPIO_Pin_14
#define PC15                            GPIO_Pin_15


//Uart pin defination
#define USART1_TX		        PA9	// out
#define USART1_RX		        PA10	// in 

#define WIZ_INT			        PC6	// in
#define WIZ_RESET		        PB9	// out
//SPI2
#define WIZ_SCS			        PB12	// out
#define WIZ_SCLK			PB13	// out
#define WIZ_MISO			PB14	// in
#define WIZ_MOSI			PB15	// out

//eeprom  PB

#define I2C_SCK	                        GPIO_Pin_6  //out
#define I2C_SDA	                        GPIO_Pin_7  //bidirection

//digital input 
#define LED1     PA0
#define LED2     PA1
#define LED3     PA2
#define LED4     PA3
#define KEY1     PA4
#define KEY2     PA5
#define KEY3     PA6
#define KEY4     PA7
// 

#pragma pack(1)
typedef struct _DATE_TIME
{
  uint8 year[2];
  uint8 month;
  uint8 day;
  uint8 hour;
  uint8 minute;
  uint8 second;
}DATE_TIME;

//=================================================
typedef struct _CONFIG_MSG
{
  uint8 op[4];//header: FIND;SETT;FACT...
  /****************************************************************************************/
  /********** ONLY BELOW PARAMS INCLUDED IN CRC16 CACULATION AND STORED IN FLASH **********/
  uint8 mac[6];
  uint8 sw_ver[2];
  //device name & serial number; 1205
  
  uint8 lip[4];
  uint8 sub[4];
  uint8 gw[4];
  uint8 dns[4];	
  uint8 dhcp; //0: static IP, 1: dynamic IP
  uint8 debug;
  uint16 fw_len; //received firmware length from http or firmware server
  uint8 state;
  uint8 device_name[16];
  uint8 device_serial[16];

  //http server port number
  uint16 http_port;
  //device flags
  uint8 flag;

  
  //automatically f/w update server information
  /*
  if the auto f/w updating is enabled, module will communication with f/w server to get the latest f/w (only after booting).
  */
  uint8 fw_auto_update_flag; //fw auto updating enable flag, default is disabled
  uint8 fw_server_ip[4]; //firmware server ip address
  uint16 fw_server_port;
  
  //firmware information
 // uint32 fw_len; //received firmware length from http or firmware server
  uint32 fw_checksum; //calculated checksum of received firmware
  
  
  /****************************** ONLY ABOVE PARAMS INCLUDED IN CRC16 CACULATION *************************************/
  /*******************************************************************************************************************/
  //module status
  uint32 on_time; //module working time (in second) afer power on or reset, the value must be clear in the initialization stage.
  uint8 num_log; //log message number; the latest 256 log messages will be saved in eeprom. 

}CONFIG_MSG;
#pragma pack()
#define CONFIG_MSG_LEN        sizeof(CONFIG_MSG) - 4 // the 4 bytes OP will not save to EEPROM
#define NO_NEED_CRC_MSG_LEN   14

#define RULE_START_ADDR       CONFIG_MSG_LEN
#define RULE_LEN              sizeof(USER_RULE)
#define TOTAL_RULE_NUM        16

//module state definination
#define BOOT_WITHOUT_APP      0x00
#define FW_UPDATE_CONFIG      0x10
#define WEBPAGE_UPDATE_CONFIG 0x11

#define FW_RXD_HTTP           0x02
#define FW_RXD_SERVER         0x03
#define FW_APP_NORMAL         0x80
//#define 

#define SOCK_FW                   5
#define SOCK_DATA                 0       //	
#define SOCK_CONFIG		  1	// UDP
#define SOCK_DNS		  2	// UDP
#define SOCK_DHCP		  3	// UDP
#define SOCK_NOTIFY               4       //tcp or udp
#define SOCK_NTP                  5       //time
#define SOCK_WB                   6       //tcp, telnet
#define SOCK_HTTP                 7

#define HTTP_PWD_TIMEOUT        60 //300 seconds = 5 minutes
#define CONSOLE_TIMEOUT         HTTP_PWD_TIMEOUT
#define MAX_BUF_SIZE		1460
#define KEEP_ALIVE_TIME	        30	// 30sec


#define ON	1
#define OFF	0

#define HIGH		1
#define LOW		0

#define __GNUC__

// SRAM address range is 0x2000 0000 ~ 0x2000 BFFF (48KB)
#define SOCK_BUF_ADDR 	0x2000C000
#define SIO_BUF_ADDR 	(SOCK_BUF_ADDR + MAX_BUF_SIZE)

#define TX_RX_MAX_BUF_SIZE	2048
//#define TX_BUF	0x20004000
//#define RX_BUF	(TX_BUF+TX_RX_MAX_BUF_SIZE)
//extern uint8 TX_BUF[TX_RX_MAX_BUF_SIZE];
//extern uint8 RX_BUF[TX_RX_MAX_BUF_SIZE];
extern CONFIG_MSG  ConfigMsg, RecvMsg;


#define ApplicationAddress 	0x08008000  //boot size is 32K
#define ApplicationBackAddress  0x08024000 //app size is 112K, 32KB webpage space included, app program is from 0x08008000 to 0x0801C000

#endif