
#include "httputil.h"
#include "webpage.h"
#include "at24c16.h"
#include "iap.h"
#include "device.h"

#include "serial.h"//serial to web test


//#define DEBUG_HTTP  1
#define   PACKET_LEN  2048

extern CONFIG_MSG  ConfigMsg;
extern char tx_buf[MAX_URI_SIZE];
extern char rx_buf[MAX_URI_SIZE];

/*http*/
uint8 is_login = 0;
extern vu8 http_time_flag;
extern vu16 http_time_cnt;
//
extern uint32 totalseconds;
//

extern uint8 reboot_flag;//defined in main
uint8 boundary[64];

static void make_basic_config_setting_json_callback(int8* buf, CONFIG_MSG config_msg)
{
  sprintf(buf,"BasicSettingCallback({\"ver\":\"%d.%d\",\
\"dname\":\"%s\",\
\"snum\":\"%s\",\
\"mac\":\"%02X:%02X:%02X:%02X:%02X:%02X\",\
\"lip\":\"%d.%d.%d.%d\",\
\"gw\":\"%d.%d.%d.%d\",\
\"sub\":\"%d.%d.%d.%d\",\
\"dns\":\"%d.%d.%d.%d\"});",
config_msg.sw_ver[0],config_msg.sw_ver[1],
config_msg.device_name,
config_msg.device_serial,
config_msg.mac[0],config_msg.mac[1],config_msg.mac[2],config_msg.mac[3],config_msg.mac[4],config_msg.mac[5],
config_msg.lip[0],config_msg.lip[1],config_msg.lip[2],config_msg.lip[3],
config_msg.gw[0],config_msg.gw[1],config_msg.gw[2],config_msg.gw[3],
config_msg.sub[0],config_msg.sub[1],config_msg.sub[2],config_msg.sub[3],
config_msg.dns[0],config_msg.dns[1],config_msg.dns[2],config_msg.dns[3]
);
}

//processing http protocol , and excuting the followed fuction.
void do_http(uint8 ch)
{
  //u_char ch=SOCK_HTTP;
  int len;

  st_http_request *http_request;
  memset(rx_buf,0x00,MAX_URI_SIZE);
  http_request = (st_http_request*)rx_buf;		// struct of http request
  
  /* http service start */
  switch(getSn_SR(ch))
  {
    case SOCK_INIT:
      listen(ch);
      break;
    case SOCK_LISTEN:
      if ((len = getSn_RX_RSR(ch)) > 0)
        if(ConfigMsg.debug) printf("listen: %d\r\n",len);
      break;
    case SOCK_ESTABLISHED:
    //case SOCK_CLOSE_WAIT:
      if(getSn_IR(ch) & Sn_IR_CON)
      {
        setSn_IR(ch, Sn_IR_CON);
        http_time_cnt = 0;
      }
      if ((len = getSn_RX_RSR(ch)) > 0)		
      {        			
        len = recv(ch, (uint8*)http_request, len); 
        *(((u_char*)http_request)+len) = 0;
        proc_http(ch, (uint8*)http_request); // http
        disconnect(ch);
      }
   
      break;
   
    case SOCK_CLOSE_WAIT:   
      if ((len = getSn_RX_RSR(ch)) > 0)
      {
        //printf("close wait: %d\r\n",len);
        len = recv(ch, (uint8*)http_request, len);       
        *(((u_char*)http_request)+len) = 0;
        proc_http(ch, (uint8*)http_request); // request is processed
      }
      disconnect(ch);
      break;
   
    case SOCK_CLOSED:                   
      socket(ch, Sn_MR_TCP, DEFAULT_HTTP_PORT, 0x00);    /* reinitialize the socket */
      break;
    default:
    break;
  }// end of switch 
 
}

void proc_http(SOCKET s, uint8 * buf)
{

  int8* name; //get method request file name
  int8 post_name[32]={0x00,}; //post method request file name
  unsigned long file_len;
  uint16 send_len;
  uint8* http_response;
  st_http_request *http_request;
  memset(tx_buf,0x00,MAX_URI_SIZE);
  http_response = (u_char*)rx_buf;
  http_request = (st_http_request*)tx_buf;
  parse_http_request(http_request, buf);    // After analyze request, convert into http_request
  
  //method Analyze
  switch (http_request->METHOD)				
  {
    case METHOD_ERR :
      if(strlen((char const*)boundary)>0)
      {
        printf("Error=%s\r\n",http_request->URI);
      }
      else
      {
        memcpy(http_response, ERROR_REQUEST_PAGE, sizeof(ERROR_REQUEST_PAGE));
        send(s, (u_char *)http_response, strlen((char const*)http_response));
      }
      break;
    case METHOD_HEAD:
    case METHOD_GET:
      //get file name from uri
      name=http_request->URI;
      
      if(strcmp(name,"/config.html")==0 || strcmp(name,"/")==0 || (strcmp(name,"/index.html")==0))
      {
#ifdef DEBUG_HTTP
        printf("GET config.html @ %d\r\n", http_time_cnt);
#endif
        file_len=strlen(CONFIG_HTML);
        make_http_response_head((unsigned char*)http_response, PTYPE_HTML, (uint32)file_len);
        send(s, http_response, strlen((char const*)http_response));
        send_len=0;
        while(file_len)//ҳзֺη
        {
          if(file_len>PACKET_LEN)
          {
            if(getSn_SR(s)!=SOCK_ESTABLISHED)
            {
              return;
            }
            send(s, (uint8 *)CONFIG_HTML+send_len, PACKET_LEN);
            send_len+=PACKET_LEN;
            file_len-=PACKET_LEN;
          }
          else
          {
            send(s, (uint8 *)CONFIG_HTML+send_len, file_len);
            send_len+=file_len;
            file_len-=file_len;
          }
        }
      }
      else if(strcmp(name,"/widget.pl")==0)//ҳһμغҳ
      {
        memset(tx_buf,0,MAX_URI_SIZE);
        //call 
        make_basic_config_setting_json_callback(tx_buf,ConfigMsg);//豸Ϣ
       
        sprintf((char *)http_response,"HTTP/1.1 200 OK\r\nContent-Type: text/html\r\nContent-Length:%d\r\n\r\n%s",strlen(tx_buf),tx_buf);
        send(s, (u_char *)http_response, strlen((char const*)http_response));
      }
      else if(strcmp(name,"/io.pl")==0)//IO״̬
      {
        memset(tx_buf,0,MAX_URI_SIZE);
        json_io_status((int8*)tx_buf);
        sprintf((char *)http_response,"HTTP/1.1 200 OK\r\nContent-Type: text/html\r\nContent-Length:%d\r\n\r\n%s",strlen(tx_buf),tx_buf);
        send(s, (u_char *)http_response, strlen((char const*)http_response));          
      }
      else
      {
        memcpy(http_response, ERROR_HTML_PAGE, sizeof(ERROR_HTML_PAGE));
        send(s, (uint8 *)http_response, strlen((char const*)http_response));
      }
      break;
      /*POST method*/
    case METHOD_POST:
      
      //get file name from uri
      //name=http_request->URI;
      mid(http_request->URI, "/", " HTTP", post_name);
#ifdef DEBUG_HTTP
      printf("\r\n--------------\r\n");
      printf("post: %s\r\n", post_name);
      printf("\r\n--------------\r\n");
#endif
      if(strcmp(post_name, "firmware.pl")!=0)//not firmware upload
      {
#ifdef DEBUG_HTTP
        printf("not firmware upload\r\n");
#endif

        if(*(((uint8*)http_request->URI)+strlen((char*)http_request->URI)-1) == 0x0a)//only http header
        {
          uint16 len=0;
          uint16 content_len=0;
          int8 sub[10];
          //get Content-Length  
          mid((char*)http_request->URI,"Content-Length: ","\r\n",sub);
          content_len=ATOI(sub,10);
#ifdef DEBUG_HTTP
          printf("content len=%d\r\n",content_len);
#endif
          if(content_len>2048)content_len=2048;
          while(len!=content_len)
          {
            
            len=getSn_RX_RSR(s);
#ifdef DEBUG_HTTP
            printf("rx len=%d\r\n",len);
#endif
            if(len>=content_len)
              len=recv(s, (u_char*)(http_request)+strlen((char*)http_request->URI)+2, content_len);
            //printf("\r\nrx_len=%d %s\r\n",len,(char*) http_request->URI);            
          }
        }
        //end of get all post data
        if(strcmp(post_name,"dout.pl")==0)//ָ
        { 
          uint8* param;
          uint8 pin,val;
          //printf("request=%s\r\n",(int8*)http_request->URI);
          if(param = get_http_param_value(http_request->URI,"pin"))//ȡԣܽţ
          {
            pin=(uint8)ATOI((int8*)param,10);
          }
          if(param = get_http_param_value(http_request->URI,"val"))//ȡָʾܽŵֵ/ͣ
          {
            val=(uint8)ATOI((int8*)param,10);
          }
#ifdef DEBUG_HTTP
          printf("pin=%d,val=%d\r\n",pin,val);
#endif
          //response to browser
          if(val==1)//light is on
          {
            //set pin voltage level to 1; light off (low active)
            set_dout(pin,val);//ùܽ
            memcpy(http_response, DOUT_RES_0, sizeof(DOUT_RES_0));
            send(s, (uint8 *)http_response, strlen((int8 const*)http_response));
          }
          else
          {
            set_dout(pin,val);
            memcpy(http_response, DOUT_RES_1, sizeof(DOUT_RES_1));
            send(s, (uint8 *)http_response, strlen((int8 const*)http_response));
          }
        }
        else if(strcmp(post_name,"io.pl")==0)//IO״ָ̬
        {
          memset(tx_buf,0,MAX_URI_SIZE);
          json_io_status((int8*)tx_buf);
          //sprintf(tx_buf, "IoStatusCallback(%s);", BUFPUB);
          sprintf((char *)http_response,"HTTP/1.1 200 OK\r\nContent-Type: text/html\r\nContent-Length:%d\r\n\r\n%s",strlen(tx_buf),tx_buf);
          send(s, (u_char *)http_response, strlen((char const*)http_response));          
        }
        else if(strcmp(post_name,"config.pl")==0)//ָ
        {
          cgi_ipconfig(http_request);//ȡϢдeeprom

          make_cgi_response(5,(int8*)ConfigMsg.lip,tx_buf);         
          sprintf((char *)http_response,"HTTP/1.1 200 OK\r\nContent-Type: text/html\r\nContent-Length:%d\r\n\r\n%s",strlen(tx_buf),tx_buf);
          send(s, (u_char *)http_response, strlen((char *)http_response));		
          reboot_flag=1;//豸
          return;
          
        }
        else
        {         
          memcpy(http_response, ERROR_HTML_PAGE, sizeof(ERROR_HTML_PAGE));
          send(s, (u_char *)http_response, strlen((char const*)http_response));
        }
      }     
      break;
    default :
      break;
  }
}


void cgi_ipconfig(st_http_request *http_request)
{
  
  u_char * param;
  //u_char * ntpptr;
  //Device setting
  if(param = get_http_param_value(http_request->URI,"devicename"))//device name
  {
    memset(ConfigMsg.device_name,0x00,16);
    memcpy(ConfigMsg.device_name,param,strlen((char*)param));    
  }
  
  if((param = get_http_param_value(http_request->URI,"lip")))
  {
    inet_addr_((u_char*)param, ConfigMsg.lip);	
  }
  if((param = get_http_param_value(http_request->URI,"gw")))
  {
    inet_addr_((u_char*)param, ConfigMsg.gw);	
  }
  if((param = get_http_param_value(http_request->URI,"sub")))
  {
    inet_addr_((u_char*)param, ConfigMsg.sub);		
  }
  if((param = get_http_param_value(http_request->URI,"dns")))
  {
    inet_addr_((u_char*)param, ConfigMsg.dns);		
  }
  /* Program the network parameters received into eeprom */
  write_config_to_eeprom();
}

void trimp(uint8* src, uint8* dst, uint16 len)
{
  uint16 i;
  for(i=0;i<len;i++)
  {
    if(*(src+i)!=0x00) 
      *(dst+i)=*(src+i);
    else 
      *(dst+i)=0x20;
  }
}
uint16 make_msg_response(uint8* buf,int8* msg)
{
  uint16 len=strlen(msg);
  sprintf((char *)buf,"HTTP/1.1 200 OK\r\nContent-Type: text/html\r\nContent-Length:%d\r\n\r\n%s",len,msg);
  return len;
}
void make_cgi_response(uint16 delay, int8* url,int8* cgi_response_buf)
{
  sprintf(cgi_response_buf,"<html><head><title>iWeb - Configuration</title><script language=javascript>j=%d;function func(){document.getElementById('delay').innerText=' '+j + ' ';j--;setTimeout('func()',1000);if(j==0)location.href='http://%d.%d.%d.%d/';}</script></head><body onload='func()'>please wait for a while, the module will boot in<span style='color:red;' id='delay'></span> seconds.</body></html>",delay,url[0],url[1],url[2],url[3]);
  return;
}

void make_pwd_response(int8 isRight,uint16 delay,int8* cgi_response_content, int8 isTimeout)
{
  if (isRight==1)
    sprintf(cgi_response_content,"<html><head><title>Password - iWeb</title><script language=javascript>j=%d;function func(){document.getElementById('delay').innerText=' '+j+' ';j--;setTimeout('func()',1000);if(j==0)location.href='config.html';}</script></head><body onload='func()'>Please wait for a while, the configuration page will be loaded automatically in<span style='color:red;' id='delay'></span> seconds.</body></html>",delay);
  else
  {
    if (isTimeout==0)
      sprintf(cgi_response_content,"<html><head><title>Password - iWeb</title><script language=javascript>j=%d;function func(){document.getElementById('delay').innerText=' '+j+' ';j--;setTimeout('func()',1000);if(j==0)location.href='index.html';}</script></head><body onload='func()'>The password you input is incorrect, please check it again. </br> This page will go back in<span style='color:red;' id='delay'></span> seconds.</body></html>",delay);
  }
  if(isTimeout==1)
    sprintf(cgi_response_content,"<html><head><title>Password - iWeb</title><script language=javascript>j=%d;function func(){document.getElementById('delay').innerText=' '+j+' ';j--;setTimeout('func()',1000);if(j==0)location.href='index.html';}</script></head><body onload='func()'>You have NOT do any operation more than 5 minutes, please input your password again. </br> This page will go back in<span style='color:red;' id='delay'></span> seconds.</body></html>",delay);
}

