#include <stdio.h>
#include <string.h>
#include "types.h"
#include "config.h"
#include "serial.h"
#include "w5500.h"
#include "socket.h"
#include "seg.h"
#include "util.h"


extern CONFIG_MSG  ConfigMsg;

uint8 gBUFU2E[2048];
uint8 gBUFE2U[2048];

uint16 u2e_size = 0;
//uint8  sw_idx   = 0;


uint16 e2u_size = 0;
uint16 e2u_idx  = 0;

//Client mode 'Started' msg output flag
uint8 b_connecting_printed = 0;
uint8 b_listening_printed = 0;

static uint16 anyport = 1000;

//for seg 
extern vu16 nagle;//unit: ms
extern vu16 inact;//uint: s
extern vu16 recon;//uint: ms

//to avoid connect command executed more than 1 times!!! 
//after connect command, w5200 does not transfer its state to SYN SENT immediatly.
uint8 connect_cmd_flag = 0; 

void do_seg(void)
{
  unsigned char state;
  state=getSn_SR(SOCK_DATA);
  switch(state)
  {
  case SOCK_UDP:
    if(_kbhit() || u2e_size)               uart2ether();
    if(getSn_RX_RSR(SOCK_DATA) || e2u_size) ether2uart();
    break;
  case SOCK_SYNSENT:
    //printf("s");
    break;
  case SOCK_INIT:
    if(ConfigMsg.mode == TCP_CLIENT_MODE)
    {
      //if reconn_val>0 then waitfor reconntimer timeout
      /*
      if(recon_val>0)
      {
        if(recon<recon_val)
          return;
        else
        {
          recon=0;
          connect(SOCK_DATA,ConfigMsg.rip, rport_val);
        }
      }
      
      */
      if(connect_cmd_flag==0)
      {
        
        connect(SOCK_DATA,ConfigMsg.rip, ConfigMsg.rport);
        
        connect_cmd_flag = 1;
      }
      else
        return;
      if((ConfigMsg.debug)) 
      {
        if(!b_connecting_printed)
        {
          b_connecting_printed=1;
          if(ConfigMsg.debug) printf("Connect %d.%d.%d.%d:%d\r\n",ConfigMsg.rip[0],ConfigMsg.rip[1],ConfigMsg.rip[2],ConfigMsg.rip[3],ConfigMsg.rport); 
        }
      }
    }
    else 
    {
      listen(SOCK_DATA);
      if((ConfigMsg.debug)) 
      {
        if(!b_listening_printed)
        {
          b_listening_printed=1;
          if(ConfigMsg.debug) printf("Listen on %d.%d.%d.%d:%d\r\n",ConfigMsg.lip[0],ConfigMsg.lip[1],ConfigMsg.lip[2],ConfigMsg.lip[3],ConfigMsg.lport);
        }
      }
    }
    break;
  case SOCK_LISTEN:
    
    if(_kbhit() || u2e_size)
    {
      uart2ether();
    }
    break;
  case SOCK_ESTABLISHED:
    if(getSn_IR(SOCK_DATA) & Sn_IR_CON)
    {
    
      //ConfigMsg.state = ST_CONNECT;
      setSn_IR(SOCK_DATA, Sn_IR_CON);
      if(ConfigMsg.debug) printf("Connected\r\n");
      
      if(b_connecting_printed)b_connecting_printed=0;
      if(b_listening_printed)b_listening_printed=0;
     
      //seg parameter: initialization
      inact=0;
      nagle=0;
      
    }
    if(_kbhit() || u2e_size)
    {
      uart2ether();
    }
    if(USART_GetITStatus(USART1, USART_IT_RXNE) != RESET)
    {
      USART_ClearITPendingBit(USART1, USART_IT_RXNE);
    }
    if(getSn_RX_RSR(SOCK_DATA) || e2u_size) 
    {
      ether2uart();
    }
   
    //inactivity timer
    if(ConfigMsg.inactivity>0)
    {
      if(inact>=ConfigMsg.inactivity)
      {
        inact=0;
        disconnect(SOCK_DATA);
      }
    }

    break;
  case SOCK_CLOSE_WAIT:      
    while(getSn_RX_RSR(SOCK_DATA) || e2u_size) ether2uart();
    disconnect(SOCK_DATA);
    break;
  case SOCK_CLOSED:
  case SOCK_FIN_WAIT:	 
    close(SOCK_DATA);
    connect_cmd_flag = 0;
    e2u_size = 0;
    e2u_idx  = 0;
    
    if(ConfigMsg.mode ==  UDP_MODE)
    {
      socket(SOCK_DATA,Sn_MR_UDP,ConfigMsg.lport,0);
      //ConfigMsg.state = ST_OPEN;
    }
    else if(ConfigMsg.mode == TCP_CLIENT_MODE)
    {
      while(socket(SOCK_DATA,Sn_MR_TCP,anyport++,Sn_MR_ND)==0);
    
    }
    else if (ConfigMsg.mode == TCP_SERVER_MODE )
    { 	
      socket(SOCK_DATA,Sn_MR_TCP,ConfigMsg.lport,Sn_MR_ND);	//Sn_MR_ND
      
    }
    break;
  default:
    //printf("0x%02x ", state);
    break;         
  }
  return;
}

void uart2ether(void)
{
 
  if(_kbhit()) 
  {
    
   
    //u2e_size = uart_gets(gBUFU2E,_kbhit());	
  }
  //
  if(ConfigMsg.nagle>0)//nagle timer; the serial buffer overflow should be checked here.
  {
    if(nagle<ConfigMsg.nagle)
      return;
    else
      nagle=0;
  }
  
  u2e_size = uart_gets(gBUFU2E,_kbhit());
  //printf("u2e size=%d\r\n",u2e_size);
  if(u2e_size)
  {
    switch(getSn_SR(SOCK_DATA))
    {
    case SOCK_UDP : 
      if(u2e_size)
      {
        sendto(SOCK_DATA, gBUFU2E, u2e_size, ConfigMsg.rip,ConfigMsg.rport);
        u2e_size = 0;
      }
      break;
    case SOCK_ESTABLISHED:
    case SOCK_CLOSE_WAIT:
    
      if(u2e_size)
      {
        send(SOCK_DATA, gBUFU2E, u2e_size);
        u2e_size = 0;
        //clear parameter
        inact=0;
       }
      break;
  
    case SOCK_LISTEN: 
      return;
    default:  
      if(ConfigMsg.mode == TCP_MIXED_MODE) 
      {
        return;
      }
      break;
    }//end switch
  } 
     
}

void ether2uart(void)
{
  uint16 len;
  uint8  peerip[4];
  uint16 peerport;

  len = getSn_RX_RSR(SOCK_DATA);
  if (len > 2048) len = 2048; // avoid overflow
  
  if(!e2u_idx && !e2u_size && len)
  {
    switch(getSn_SR(SOCK_DATA))
    {
    case SOCK_UDP:
      e2u_size = recvfrom(SOCK_DATA,gBUFE2U,len,peerip,&peerport);
      if(memcmp(peerip,ConfigMsg.rip,sizeof(peerip)) || ConfigMsg.rport!= peerport) return;
      break;
    case SOCK_ESTABLISHED:
    case SOCK_CLOSE_WAIT:
      e2u_size = recv(SOCK_DATA,gBUFE2U,len);
      //printf("e2u=%d,len=%d\r\n",e2u_size,len);
      break;
    default:
      break;
    }
  }
  
  if(ConfigMsg.flow==0)
  {
    e2u_idx = 0;
    while(e2u_size)
    {
      //led on
      //led_g_on();
      PutByte(1,gBUFE2U[e2u_idx]);//PutByte(0/1,buf) 0:UART1,1:UART2
      //led off
      //led_g_off();
      //
      e2u_size--;
      e2u_idx++;
    }
    e2u_idx = 0;
  }
  else if(e2u_size)
  {
    //led on
    //led_g_on();
    PutByte(1,gBUFE2U[e2u_idx++]);//PutByte(0/1,buf) 0:UART1,1:UART2
    //led off
    //led_g_off();
    if(e2u_idx == e2u_size)
    {
      e2u_idx  = 0;
      e2u_size = 0;
    }
  }
  else
  {
    ;
  }
}
