
#include "config.h"
#include "util.h"
//#include "W5200\w5200.h"
#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include <ctype.h>

#include "md5.h"




/*******************************************************************************
* Function Name  : Delay_us
* Description    : Delay per micro second.
* Input          : time_us
* Output         : None
* Return         : None
*******************************************************************************/

void Delay_us( u8 time_us )
{
  register u8 i;
  register u8 j;
  for( i=0;i<time_us;i++ )    
  {
    for( j=0;j<5;j++ )          // 25CLK
    {
      asm("nop");       //1CLK         
      asm("nop");       //1CLK         
      asm("nop");       //1CLK         
      asm("nop");       //1CLK         
      asm("nop");       //1CLK                  
    }      
  }                              // 25CLK*0.04us=1us
}

/*******************************************************************************
* Function Name  : Delay_ms
* Description    : Delay per mili second.
* Input          : time_ms
* Output         : None
* Return         : None
*******************************************************************************/

void Delay_ms( u16 time_ms )
{
  register u16 i;
  for( i=0;i<time_ms;i++ )
  {
    Delay_us(250);
    Delay_us(250);
    Delay_us(250);
    Delay_us(250);
  }
}


int putchar(int ch)
{
  // Write a character to the USART
  USART_SendData(USART1, (uint8_t) ch);

  //  Loop until the end of transmission 
  while(USART_GetFlagStatus(USART1, USART_FLAG_TXE) == RESET)
  {
    //GPIO_ResetBits(GPIOB, DOUT1); // led on
  };
  //GPIO_ResetBits(GPIOB, DOUT0); // led off

  return ch;
}

int getchar(void)
{
  int ch;

	while(USART_GetFlagStatus(USART1, USART_FLAG_RXNE) == RESET){
           IWDG_ReloadCounter();//feed iwdg
	}

	ch = USART_ReceiveData(USART1);

  return ch;
}

/*******************************************************************************
* Function Name  : time_return
* Description    :  
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

uint32 time_return(void) 
{
  extern uint32 my_time; 
  return my_time;
}

/**
@brief	CONVERT STRING INTO INTEGER
@return	a integer number
*/
uint16 ATOI(
	char* str,	/**< is a pointer to convert */
	uint16 base	/**< is a base value (must be in the range 2 - 16) */
	)
{
        unsigned int num = 0;
        while (*str !=0)
                num = num * base + C2D(*str++);
	return num;
}

uint32 ATOI32(
	char* str,	/**< is a pointer to convert */
	uint16 base	/**< is a base value (must be in the range 2 - 16) */
	)
{
        uint32 num = 0;
        while (*str !=0)
                num = num * base + C2D(*str++);
	return num;
}


void itoa(uint16 n,uint8 str[5], uint8 len)
{
  
  uint8 i=len-1;

  memset(str,0x20,len);
  do{
  str[i--]=n%10+'0';
  
 }while((n/=10)>0);

 return;
}
/**
@brief	CONVERT STRING INTO HEX OR DECIMAL
@return	success - 1, fail - 0
*/
int ValidATOI(
	char* str, 	/**< is a pointer to string to be converted */
	int base, 	/**< is a base value (must be in the range 2 - 16) */
	int* ret		/**<  is a integer pointer to return */
	)
{
  int c;
  char* tstr = str;
  if(str == 0 || *str == '\0') return 0;
  while(*tstr != '\0')
  {
    c = C2D(*tstr);
    if( c >= 0 && c < base) tstr++;
    else    return 0;
  }
  
  *ret = ATOI(str,base);
  return 1;
}

/**
@brief	replace the specified character in a string with new character
*/ 
void replacetochar(
	char * str, 		/**< pointer to be replaced */
	char oldchar, 	/**< old character */
	char newchar	/**< new character */
	)
{
  int x;
  for (x = 0; str[x]; x++) 
    if (str[x] == oldchar) str[x] = newchar;	
}
/**
@brief	CONVERT CHAR INTO HEX
@return	HEX
  
This function converts HEX(0-F) to a character
*/
char C2D(
	uint8 c	/**< is a character('0'-'F') to convert to HEX */
	)
{
	if (c >= '0' && c <= '9')
		return c - '0';
	if (c >= 'a' && c <= 'f')
		return 10 + c -'a';
	if (c >= 'A' && c <= 'F')
		return 10 + c -'A';

	return (char)c;
}

uint16 swaps(uint16 i)
{
  uint16 ret=0;
  ret = (i & 0xFF) << 8;
  ret |= ((i >> 8)& 0xFF);
  return ret;	
}

uint32 swapl(uint32 l)
{
  uint32 ret=0;
  ret = (l & 0xFF) << 24;
  ret |= ((l >> 8) & 0xFF) << 16;
  ret |= ((l >> 16) & 0xFF) << 8;
  ret |= ((l >> 24) & 0xFF);
  return ret;
}

/*
Convert 2 bytes uint8 to a uint16
*/
uint16 toUint16(uint8 dat[2])
{
  uint16 ret=0;
  ret=dat[0];
  ret=ret<<8;
  ret+=dat[1];
  return (ret);
}
//get mid str
void mid(int8* src, int8* s1, int8* s2, int8* sub)
{
  int8* sub1=strstr(src,s1);
  sub1+=strlen(s1);
  int8* sub2=strstr(sub1,s2);
 // int8 sub[256];
  uint16 n=sub2-sub1;
  strncpy(sub,sub1,n);
  sub[n]=0;
}
//md5 
void md5(uint8* output, uint8* input)
{
  uint8 digest[16];
  md5_ctx context;
  md5_init(&context);
  md5_update(&context,input,strlen((char*)input));
  md5_final(digest,&context);
  memcpy(output,digest,16);
}

uint8 is_ipaddr(uint8* ipaddr)
{
   uint16 tval = 0;
   uint8  dotcnt = 0;
   uint8  i = 0;
   if(strlen((char*)ipaddr) > 15 || strlen((char*)ipaddr) < 7) return 0;
   for(i = 0; i < strlen((char*)ipaddr) ; i++)
   {
      if(isdigit(ipaddr[i]))
      {
         tval = (tval * 10) + ipaddr[i] - '0';
         if(tval > 255) return 0;
      }
      else if(ipaddr[i] == '.')
      {
         if(tval > 255) return 0;
         dotcnt++;
         if(dotcnt > 3) return 0;
         tval = 0;
      }
      else return 0;
   }
   if(dotcnt!=3) return 0;
   return 1;
}


#ifdef USE_FULL_ASSERT
/*******************************************************************************
* Function Name  : assert_failed
* Description    : Reports the name of the source file and the source line number
*                  where the assert_param error has occurred.
* Input          : - file: pointer to the source file name
*                  - line: assert_param error line source number
* Output         : None
* Return         : None
*******************************************************************************/
void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  while (1)
  {
  }
}

#endif



