#include "w5500/config.h"
#include "w5500/socket.h"
#include "w5500/w5500.h"
#include "w5500/util.h"
#include <string.h>
#include <stdlib.h>
#include <stdio.h>

void WIZ_SPI_Init(void)
{
  PERCFG |=  0x02;            // PERCFG.U1CFG = 1
  P1SEL  |=  0xE0;            // P1_7, P1_6, and P1_5 are peripherals

  P1SEL  &= ~0x10;            // P1_4 is GPIO (SSN)
  P1DIR  |=  0x10;            // SSN is set as output

  // Set baud rate to max (system clock frequency / 8)
  U1BAUD = 0x00;              // BAUD_M = 0
  U1GCR |= 0x11;              // BAUD_E = 17
  
  U1CSR &= ~0xA0;             // SPI Master Mode

  // Configure phase, polarity, and bit order
  U1GCR &= ~0xC0;             // CPOL = CPHA = 0
  U1GCR |= 0x20;              // ORDER = 1  
  
  P1SEL  &= ~0x08;            // P1_3 is GPIO (SSN)
  P1DIR  |=  0x08;            // P1_3 is set as output

}

void WIZ_RST(uint8 val)
{
  if (val == LOW) {
   P1_3=0; 
  }else if (val == HIGH){
   P1_3=1; 
  }
}
// Connected to Data Flash
void WIZ_CS(uint8 val)
{
  if (val == LOW) {
     P1_4=0; 
  }else if (val == HIGH){
     P1_4=1; 
  }
}


uint8 SPI2_SendByte(uint8 byte)
{
  uint8 temp;
  U1DBUF = byte;
  while (!(U1CSR&0x02)); 
  
  U1CSR &= 0xFD;
    
  temp = U1DBUF;
  return temp;
}
