#ifndef _DEVICE_H_
#define _DEVICE_H_
#include "ioCC2530.h"      // ļõͷļ
#define DEVICE_ID "W5500"

#define FW_VER_HIGH  1
#define FW_VER_LOW    0
// Macro for checking status of the crystal oscillator
#define XOSC_STABLE (SLEEPSTA & 0x40)

// Macro for checking status of the high frequency RC oscillator.
#define HIGH_FREQUENCY_RC_OSC_STABLE    (SLEEPSTA & 0x20)
#define SET_MAIN_CLOCK_SOURCE(source) \
   do {                               \
      if(source) {                    \
        CLKCONCMD |= 0x40;               \
        while(!HIGH_FREQUENCY_RC_OSC_STABLE); \
        SLEEPCMD |= 0x04;                \
      }                               \
      else {                          \
        SLEEPCMD &= ~0x04;               \
        while(!XOSC_STABLE);          \
        asm("NOP");                   \
        CLKCONCMD &= ~0x47;              \
        SLEEPCMD |= 0x04;                \
      }                               \
   }while (0)

typedef  void (*pFunction)(void);
void set_default(void);
void set_network(void);

void Reset_W5500(void);
void do_tcpclient(uint8 s);

#endif